			include "propeller.i"
			include "demo.i"

			org	0
PINMASK			=	$0c
FRAMES			=	26

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_1_00_000_00000000000_000_0_00000000 >> 23

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

vbl
			add	frame, #1
			neg	field, frame
			shr	field, #1
			add	field, =FRAMES
			shl	field, #4

			mov	VSCL, #1

			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71 + 16
			waitvid	zero, #0

			movs	VCFG, #PINMASK

			mov	line, #0
			mov	y, #240
vline
			mov	VSCL, =620
			waitvid	zero, #0

			mov	x, #15
			mov	VSCL, =16 << 12 | 256
xloop			
			mov	t1, field
			mins	t1, #0
			max	t1, #FRAMES * 16
			add	t1, #anim
			add	t1, line
			movs	:p_wv, t1
			add	field, #16
:p_wv			waitvid	palette, 000
			djnz	x, #xloop

			mov	VSCL, =620
			waitvid	zero, #0

			sub	field, #15 * 16
			add	line, #1
			cmp	line, #16	wz
		if_z	mov	line, #0
		if_z	add	field, #5 * 16

			djnz	y, #vline

			movs	VCFG, #0
			jmp	#vbl

palette			byte	%00000000, %00000100, %00001000, %00001100

anim			file	"cubeanim.raw"
			long	0[16]

			pool

frame			long	0

t1			res	1
t2			res	1
x			res	1
y			res	1
field			res	1
line			res	1

			vfit	496
