			include "propeller.i"
			include "demo.i"

			org	0
PINMASK			=	$10

			mov	t1, #DITHER_HALF
			wrbyte	t1, =@ditherstyle	' In preparation of final spinner

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_1_00_000_00000000000_000_0_00000000 >> 23

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2		wz
		if_z	jmp	#:w

vbl
			mov	sin_a, frame
			max	sin_a, =$7ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	xoffset, sin_a
			shr	xoffset, #8		' [0, 255]
			xor	xoffset, =255
			add	xoffset, #8
			max	xoffset, =255

			mov	xsmooth, xoffset
			and	xsmooth, #15
			shl	xsmooth, #4
			shr	xoffset, #4

			add	frame, #19

			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #PINMASK

			mov	VSCL, =5080 / 2
			mov	count, =88 * 2
:lp			waitvid	zero, #0
			djnz	count, #:lp

			mov	rowaddr, =$8000
			mov	ycount, #32
lplft
			mov	VSCL, =620
			sub	VSCL, xsmooth
			waitvid	zero, #0

			mov	VSCL, =16 << 12 | 256

			mov	map, map1
			mov	t1, xoffset
			shl	t1, #1
			shl	map, t1
			mov	xcount, #16
:xlp
			mov	addr, txt1
			mov	t1, map
			shr	t1, #27
			and	t1, #3 << 3
			shr	addr, t1
			and	addr, #$ff
			shr	addr, #1		wc
			shl	addr, #7
			add	addr, rowaddr
			rdlong	fontbits, addr
		if_c	shr	fontbits, #1

			waitvid	palette, fontbits

			shl	map, #2
			djnz	xcount, #:xlp

			mov	VSCL, =364
			add	VSCL, xsmooth
			waitvid	zero, #0

			add	rowaddr, #4
			djnz	ycount, #lplft

			mov	VSCL, =620
			waitvid	zero, #0

			mov	VSCL, =3840
			waitvid	palette, =%%1111111111111111

			mov	VSCL, =620
			waitvid	zero, #0

			mov	rowaddr, =$8000
			mov	ycount, #32
lpyear
			mov	VSCL, =620
			add	VSCL, xsmooth
			waitvid	zero, #0

			mov	VSCL, =16 << 12 | 256

			mov	map, map2
			mov	t1, xoffset
			shl	t1, #1
			shr	map, t1
			mov	xcount, #16
:xlp
			mov	addr, txt2
			mov	t1, map
			shr	t1, #27
			and	t1, #3 << 3
			shr	addr, t1
			and	addr, #$ff
			shr	addr, #1		wc
			shl	addr, #7
			add	addr, rowaddr
			rdlong	fontbits, addr
		if_c	shr	fontbits, #1

			waitvid	palette, fontbits

			shl	map, #2
			djnz	xcount, #:xlp

			mov	VSCL, =364
			sub	VSCL, xsmooth
			waitvid	zero, #0

			add	rowaddr, #4
			djnz	ycount, #lpyear

			movs	VCFG, #0
			jmp	#vbl

palette			byte	0, PINMASK, 0, PINMASK

			' This is such a weird way of doing things that I had to try it. =)

txt1			byte	" lft"
txt2			byte	" 2O9"

map1			long	%%0000000012300000
map2			long	%%0001223000000000

			pool

frame			long	0

t1			res	1
t2			res	1
addr			res	1
rowaddr			res	1
count			res	1
xcount			res	1
ycount			res	1
map			res	1
fontbits		res	1
xoffset			res	1
xsmooth			res	1
sin_a			res	1

			vfit	496
