			include "propeller.i"
			include "demo.i"

PINMASK		=	$04

			org	0

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_0_00_000_00000000000_000_0_00000000 >> 23

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

vbl
			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #PINMASK

			mov	y, #16
blankline
			mov	VSCL, =620
			waitvid	zero, #0
			mov	VSCL, #0
			waitvid	palette, #0
			mov	VSCL, =364
			waitvid	zero, #0
			djnz	y, #blankline

			mov	addr, =@unpack_area
			mov	y, #240 - 16
vline
			mov	VSCL, =620
			waitvid	zero, #0

			rdlong	bits3, addr
			add	addr, #4
			mov	bits2, bits3
			rdlong	bits4, addr
			add	addr, #4
			mov	bits1, bits4
			rev	bits1, #0
			rev	bits2, #0

			mov	t1, addr
			add	t1, =8 * 16
			rdlong	bits3z, t1
			add	t1, #4
			mov	bits2z, bits3z
			rdlong	bits4z, t1
			mov	bits1z, bits4z
			rev	bits1z, #0
			rev	bits2z, #0

			mov	VSCL, =16 << 12 | 512
			waitvid	palette, bits1
			waitvid	palette, bits2
			waitvid	palette, bits3
			mov	t1, bits4
			or	t1, bits1z
			waitvid	palette, t1

			mov	t1, bits2z
			or	t1, bits1
			waitvid	palette, t1
			mov	t1, bits2
			or	t1, bits3z
			waitvid	palette, t1
			mov	t1, bits4z
			or	t1, bits3
			waitvid	palette, t1
			waitvid	palette, bits4

			mov	VSCL, =364
			waitvid	zero, #0

			djnz	y, #vline

			movs	VCFG, #0
			jmp	#vbl

palette			byte	PINMASK, 0, 0, 0

			pool

addr			res	1
t1			res	1
t2			res	1
y			res	1
bits1			res	1
bits2			res	1
bits3			res	1
bits4			res	1
bits1z			res	1
bits2z			res	1
bits3z			res	1
bits4z			res	1

			vfit	496
