			include "propeller.i"
			include "demo.i"

PINMASK			=	$0f
FLOWERSTART		=	220
SWELLSTART		=	200
EXITLINES		=	520
EXITFLOWER		=	800

			org	0

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_1_00_000_00000000000_000_0_00000000 >> 23

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

vbl
			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #PINMASK

			mov	VSCL, =5080 / 2
			waitvid	zero, #0
			waitvid	zero, #0

			mov	mulu_x, frame
			sub	mulu_x, =EXITFLOWER
			mins	mulu_x, #0
			shl	mulu_x, #2
			max	mulu_x, #255
			mov	mulu_s, mulu_x
			call	#mulu
			shr	mulu_s, #8
			max	mulu_s, #207

			mov	ycount, #208
			sub	ycount, mulu_s
			max	ycount, #172

			shl	mulu_s, #1

			add	mulu_s, #32 * 2
:pre			waitvid	zero, #0
			djnz	mulu_s, #:pre

			mov	VSCL, =310
			add	VSCL, linelength
			waitvid	linepal, =%%1111111111111111
			waitvid	linepal, =%%1111111111111111
			mov	VSCL, =2230
			sub	VSCL, linelength
			waitvid	linepal, #0
			waitvid	linepal, #0

			mov	VSCL, =5080 / 2
			waitvid	zero, #0
			waitvid	zero, #0

			mov	swell, frame
			sub	swell, =SWELLSTART
			mins	swell, #0
			shr	swell, #3
			max	swell, #98

			mov	addr, PAR
vline
			neg	t1, swell
			shl	t1, #4
			add	t1, swell
			add	t1, =620 + 960
			mov	VSCL, t1
			waitvid	zero, #0

			mov	t1, swell
			add	t1, #2
			shl	t1, #12 - 2
			andn	t1, =$fff
			add	t1, swell
			add	t1, =16 << 12 | 64
			mov	VSCL, t1		' (16 << 12 | 64) + ((swell + 2) / 4) << 12 + swell
			mov	x, #30
xloop
			rdword	bits, addr
			add	addr, #2
			mov	t1, bits
			shr	t1, #4
			shl	t1, #16
			or	bits, t1
			waitvid	bits, =%%33120
			djnz	x, #xloop

			neg	t1, swell
			shl	t1, #4
			add	t1, swell
			add	t1, =620 + 960
			mov	VSCL, t1
			waitvid	zero, #0

			neg	t1, frame
			add	t1, =170 + FLOWERSTART
			mins	t1, #0
			cmps	ycount, t1		wc wz
		if_b	sub	addr, #60

			djnz	ycount, #vline

			mov	VSCL, =5080 / 2
			waitvid	zero, #0
			waitvid	zero, #0

			mov	VSCL, =2230
			sub	VSCL, linelength
			waitvid	linepal, #0
			waitvid	linepal, #0
			mov	VSCL, =310
			add	VSCL, linelength
			waitvid	linepal, =%%1111111111111111
			waitvid	linepal, =%%1111111111111111

			mov	VSCL, #1
			waitvid	zero, #0
			movs	VCFG, #0

			add	frame, #1
			add	linelength, #9
			max	linelength, =1936

			cmp	frame, =EXITLINES	wz
		if_z	mov	linelength, #0
		if_z	mov	linepal, =$000f

			jmp	#vbl

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

linepal			long	$0f00

			pool

frame			long	0
linelength		long	0

t1			res	1
t2			res	1
x			res	1
ycount			res	1
bits			res	1
addr			res	1
swell			res	1

mulu_x			res	1
mulu_s			res	1

			vfit	496
