			include "propeller.i"
			include "demo.i"

			org	0
PINMASK			=	$04
DATA			=	@unpack_area

			' Wait for the scrolltext to be unpacked.

			mov	CNT, CNT
			add	CNT, =80000000
			waitcnt	CNT, #0

			mov	DIRA, #$ff
			movi	CTRA, #%0_00001_111_00000000_000000_000_000000 >> 23
			movi	FRQA, #$10000000 >> 23
			mov	VSCL, =1
			movi	VCFG, #%0_01_1_00_000_00000000000_000_0_00000000 >> 23

			rdlong	t1, =@nextvbl
:w			rdlong	t2, =@nextvbl
			cmp	t1, t2			wz
		if_z	jmp	#:w

vbl
			mov	sin_a, sinframe
			call	#sin
			negnz	count, sin_res
			sar	count, #11
			add	count, #112

			mov	VSCL, #1
			rdlong	t1, =@nextvbl
			waitcnt	t1, #0
			mov	VSCL, #20
			nop
			nop
			mov	VSCL, #71
			waitvid	zero, #0

			movs	VCFG, #PINMASK

			mov	VSCL, =5080 / 2
			shl	count, #1
:lp			waitvid	zero, #0
			djnz	count, #:lp

			mov	xoffset, frame

			mov	smoothx, xoffset
			and	smoothx, #15
			shl	smoothx, #4
			shr	xoffset, #4

			mov	txtaddr, =DATA
			add	txtaddr, xoffset

			mov	rowaddr, =$8000
			mov	y, #32
vline
			mov	VSCL, =620
			sub	VSCL, smoothx
			waitvid	zero, #0

			mov	x, #16
			mov	VSCL, =16 << 12 | 256
xloop
			rdbyte	addr, txtaddr
			add	txtaddr, #1
			mov	addr, addr		wz
		if_z	mov	frame, #0
		if_z	mov	addr, #32
			shr	addr, #1		wc
			shl	addr, #7
			add	addr, rowaddr
			rdlong	fontbits, addr
		if_c	shr	fontbits, #1

			waitvid	palette, fontbits

			djnz	x, #xloop

			mov	VSCL, =620 - 256
			add	VSCL, smoothx
			waitvid	zero, #0

			sub	txtaddr, #16
			add	rowaddr, #4
			djnz	y, #vline

			movs	VCFG, #0
			add	frame, #2
			add	sinframe, #50
			jmp	#vbl

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

sin			test	sin_a, =$0800	wc
			test	sin_a, =$1000	wz
			and	sin_a, =$07ff
		if_c	xor	sin_a, =$07ff
			shl	sin_a, #1
			or	sin_a, =$e000
			rdword	sin_res, sin_a
sin_ret			ret

palette			byte	0, PINMASK, 0, PINMASK

			pool

frame			long	0
sinframe		long	0

count			res	1
addr			res	1
txtaddr			res	1
rowaddr			res	1
t1			res	1
t2			res	1
x			res	1
y			res	1
fontbits		res	1
smoothx			res	1
xoffset			res	1

sin_a			res	1
sin_res			res	1

			vfit	496
